Bug 926374 - protobuf: Does not support aarch64 in f19 and rawhide
Summary: protobuf: Does not support aarch64 in f19 and rawhide
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: protobuf
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Lev Shamardin
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: ARM64, F-ExcludeArch-aarch64
TreeView+ depends on / blocked
 
Reported: 2013-03-23 16:08 UTC by Dennis Gilmore
Modified: 2013-05-14 04:37 UTC (History)
4 users (show)

Fixed In Version: protobuf-2.5.0-3.fc19
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2013-05-14 04:37:47 UTC


Attachments (Terms of Use)
Proposed patch (10.35 KB, patch)
2013-05-06 13:28 UTC, Stanislav Ochotnicky
no flags Details | Diff

Description Dennis Gilmore 2013-03-23 16:08:47 UTC
Support for the ARM 64 bit CPU architecture (aarch64) was introduced in 
autoconf 2.69.  protobuf appears to use an earlier version of 
autoconf, preventing its being built.  This can be fixed in of three ways (In order of preference):

1. Work with upstream to migrate the package to autoconf 2.69.

2. Rerun autoconf or autoreconf in %prep or %build prior to running 
configure.

3. Apply the patch at http://ausil.fedorapeople.org/aarch64/protobuf/protobuf-aarch64.patch
which updates config.guess and config.sub to recognize aarch64.

Comment 1 Conrad Meyer 2013-04-27 21:29:15 UTC
Protobuf already uses (2), I've bumped the revision number and started a build in rawhide:

http://koji.fedoraproject.org/koji/taskinfo?taskID=5309029

I think this means we just need to bump / rebuild in all branches with autoconf >= 2.69.

Comment 2 Conrad Meyer 2013-04-27 21:33:37 UTC
In fact, this isn't even needed in rawhide, 2.5.0 was already built with autoconf 2.69:

http://kojipkgs.fedoraproject.org//packages/protobuf/2.5.0/1.fc19/data/logs/x86_64/root.log

It's actually not even needed in F-18 (2.4.1) either:

http://kojipkgs.fedoraproject.org//packages/protobuf/2.4.1/12.fc18/data/logs/x86_64/root.log

Only F-17 was built with autoconf < 2.69 (2.68). Do we care about getting aarch64 into old-stable? I'm inclined to NOTABUG.

Comment 3 Stanislav Ochotnicky 2013-04-29 06:47:49 UTC
I am reopening so we don't lose track of this because AARCH64 is also affected by bug 955577. Upstream dropped support for *a lot* of archs suddenly in 2.5.0. Need to look into implementing their atomic operations using GCC atomic ops.

Comment 4 Conrad Meyer 2013-04-29 14:40:43 UTC
Looks like they support ARM 32-bit little-endian, as well as ppc32, but not 64-bit variants of either:

https://code.google.com/p/protobuf/source/browse/trunk/src/google/protobuf/stubs/platform_macros.h

Comment 5 Conrad Meyer 2013-04-29 14:41:19 UTC
If you have the hardware to test on, upstream is happy to take patches:
https://code.google.com/p/protobuf/issues/detail?id=488

Comment 6 Stanislav Ochotnicky 2013-05-06 13:28:13 UTC
Created attachment 744146 [details]
Proposed patch

I have created a patch that uses generic gcc atomic operations on architectures that are not supported as first-class citizens. The patch has been submitted upstream as well[1]


[1] https://code.google.com/p/protobuf/issues/detail?id=488#c3

Comment 7 Conrad Meyer 2013-05-06 15:54:07 UTC
Awesome! Have you tested the library on any of these platforms? The google bug just mentions building.

Comment 8 Stanislav Ochotnicky 2013-05-09 14:45:24 UTC
(In reply to comment #7)
> Awesome! Have you tested the library on any of these platforms? The google
> bug just mentions building.

I have tested clementine & muble work, but I don't know for sure which parts of protobuf they use. I would be surprised if they used these atomic functions though so it doesn't tell us much about my patch except it doesn't break working stuff :-)

Comment 9 Conrad Meyer 2013-05-09 15:45:45 UTC
Sounds good to me.

Scratch build in rawhide succeeded:
http://koji.fedoraproject.org/koji/taskinfo?taskID=5354666

Pushing to branches that have 2.5.0 now.

Comment 11 Fedora Update System 2013-05-09 17:50:11 UTC
protobuf-2.5.0-3.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/protobuf-2.5.0-3.fc19

Comment 12 Fedora Update System 2013-05-10 15:35:14 UTC
Package protobuf-2.5.0-3.fc19:
* should fix your issue,
* was pushed to the Fedora 19 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing protobuf-2.5.0-3.fc19'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2013-7863/protobuf-2.5.0-3.fc19
then log in and leave karma (feedback).

Comment 13 Fedora Update System 2013-05-14 04:37:47 UTC
protobuf-2.5.0-3.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.